"use strict";

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.check = check;

var logger = _interopRequireWildcard(require("../utils/logger"));

function _getRequireWildcardCache(nodeInterop) { if (typeof WeakMap !== "function") return null; var cacheBabelInterop = new WeakMap(); var cacheNodeInterop = new WeakMap(); return (_getRequireWildcardCache = function (nodeInterop) { return nodeInterop ? cacheNodeInterop : cacheBabelInterop; })(nodeInterop); }

function _interopRequireWildcard(obj, nodeInterop) { if (!nodeInterop && obj && obj.__esModule) { return obj; } if (obj === null || typeof obj !== "object" && typeof obj !== "function") { return { default: obj }; } var cache = _getRequireWildcardCache(nodeInterop); if (cache && cache.has(obj)) { return cache.get(obj); } var newObj = {}; var hasPropertyDescriptor = Object.defineProperty && Object.getOwnPropertyDescriptor; for (var key in obj) { if (key !== "default" && Object.prototype.hasOwnProperty.call(obj, key)) { var desc = hasPropertyDescriptor ? Object.getOwnPropertyDescriptor(obj, key) : null; if (desc && (desc.get || desc.set)) { Object.defineProperty(newObj, key, desc); } else { newObj[key] = obj[key]; } } } newObj.default = obj; if (cache) { cache.set(obj, newObj); } return newObj; }

const CHECKS = ['verifyBrowserslist', 'verifyPackageTree', 'verifyPrivateModularRoot', 'verifyWorkspaceDependencies', 'verifyWorkspaceStructure', 'verifyYarnRcYml'];

async function check(fix = false) {
  let failed = false;

  for (const checkName of CHECKS) {
    logger.debug('');
    logger.debug(`===== Running ${checkName} =====`);
    const checkCls = await Promise.resolve(`./${checkName}`).then(s => _interopRequireWildcard(require(s)));

    if (fix && checkCls.fix) {
      await checkCls.fix();
    } // if the check returns false then we fail and show the error.


    if (await checkCls.check()) {
      continue;
    } else {
      failed = true;
    }

    logger.debug(`===== Finished ${checkName} =====`);
    logger.debug('');
  }

  if (failed) {
    throw new Error(`The above errors were found during modular check`);
  }
}
//# sourceMappingURL=index.js.map