"use strict";

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.check = check;

var fs = _interopRequireWildcard(require("fs-extra"));

var path = _interopRequireWildcard(require("path"));

var logger = _interopRequireWildcard(require("../utils/logger"));

var _getModularRoot = _interopRequireDefault(require("../utils/getModularRoot"));

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

function _getRequireWildcardCache(nodeInterop) { if (typeof WeakMap !== "function") return null; var cacheBabelInterop = new WeakMap(); var cacheNodeInterop = new WeakMap(); return (_getRequireWildcardCache = function (nodeInterop) { return nodeInterop ? cacheNodeInterop : cacheBabelInterop; })(nodeInterop); }

function _interopRequireWildcard(obj, nodeInterop) { if (!nodeInterop && obj && obj.__esModule) { return obj; } if (obj === null || typeof obj !== "object" && typeof obj !== "function") { return { default: obj }; } var cache = _getRequireWildcardCache(nodeInterop); if (cache && cache.has(obj)) { return cache.get(obj); } var newObj = {}; var hasPropertyDescriptor = Object.defineProperty && Object.getOwnPropertyDescriptor; for (var key in obj) { if (key !== "default" && Object.prototype.hasOwnProperty.call(obj, key)) { var desc = hasPropertyDescriptor ? Object.getOwnPropertyDescriptor(obj, key) : null; if (desc && (desc.get || desc.set)) { Object.defineProperty(newObj, key, desc); } else { newObj[key] = obj[key]; } } } newObj.default = obj; if (cache) { cache.set(obj, newObj); } return newObj; }

async function check() {
  var _rootPackageJson$work;

  const modularRoot = (0, _getModularRoot.default)();
  const rootPackageJsonPath = path.join(modularRoot, 'package.json');
  const rootPackageJson = await fs.readJSON(rootPackageJsonPath);

  if (!rootPackageJson.private) {
    logger.error(`Modular workspace roots must be marked as private`);
    return false;
  }

  if (!(rootPackageJson !== null && rootPackageJson !== void 0 && (_rootPackageJson$work = rootPackageJson.workspaces) !== null && _rootPackageJson$work !== void 0 && _rootPackageJson$work.includes('packages/**'))) {
    logger.error(`Modular workspaces must include "packages/**" to pick up any modular packages in the worktree`);
    return false;
  }

  logger.debug('Modular root is valid.');
  return true;
}
//# sourceMappingURL=verifyPrivateModularRoot.js.map