"use strict";

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.checkBrowsers = checkBrowsers;
exports.defaultBrowsers = void 0;

var _browserslist = _interopRequireDefault(require("browserslist"));

var _chalk = _interopRequireDefault(require("chalk"));

var os = _interopRequireWildcard(require("os"));

function _getRequireWildcardCache(nodeInterop) { if (typeof WeakMap !== "function") return null; var cacheBabelInterop = new WeakMap(); var cacheNodeInterop = new WeakMap(); return (_getRequireWildcardCache = function (nodeInterop) { return nodeInterop ? cacheNodeInterop : cacheBabelInterop; })(nodeInterop); }

function _interopRequireWildcard(obj, nodeInterop) { if (!nodeInterop && obj && obj.__esModule) { return obj; } if (obj === null || typeof obj !== "object" && typeof obj !== "function") { return { default: obj }; } var cache = _getRequireWildcardCache(nodeInterop); if (cache && cache.has(obj)) { return cache.get(obj); } var newObj = {}; var hasPropertyDescriptor = Object.defineProperty && Object.getOwnPropertyDescriptor; for (var key in obj) { if (key !== "default" && Object.prototype.hasOwnProperty.call(obj, key)) { var desc = hasPropertyDescriptor ? Object.getOwnPropertyDescriptor(obj, key) : null; if (desc && (desc.get || desc.set)) { Object.defineProperty(newObj, key, desc); } else { newObj[key] = obj[key]; } } } newObj.default = obj; if (cache) { cache.set(obj, newObj); } return newObj; }

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

const defaultBrowsers = {
  production: ['supports es6-module', '>0.2%', 'not dead', 'not op_mini all'],
  development: ['supports es6-module', 'last 1 chrome version', 'last 1 firefox version', 'last 1 safari version']
};
exports.defaultBrowsers = defaultBrowsers;

function checkBrowsers(dir) {
  const current = _browserslist.default.loadConfig({
    path: dir
  });

  if (current != null) {
    return Promise.resolve();
  } else {
    return Promise.reject(new Error(_chalk.default.red('Modular requires that you specify targeted browsers.') + os.EOL + `Run ${_chalk.default.blue('modular check --fix')} to autofix this.`));
  }
}
//# sourceMappingURL=checkBrowsers.js.map